<?php

namespace xt_soapapi\xt_soapapi-php\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfModeReglement ArrayType
 * @subpackage Arrays
 */
class ArrayOfModeReglement extends AbstractStructArrayBase
{
    /**
     * The ModeReglement
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \xt_soapapi\xt_soapapi-php\StructType\ModeReglement[]
     */
    public $ModeReglement;
    /**
     * Constructor method for ArrayOfModeReglement
     * @uses ArrayOfModeReglement::setModeReglement()
     * @param \xt_soapapi\xt_soapapi-php\StructType\ModeReglement[] $modeReglement
     */
    public function __construct(array $modeReglement = array())
    {
        $this
            ->setModeReglement($modeReglement);
    }
    /**
     * Get ModeReglement value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \xt_soapapi\xt_soapapi-php\StructType\ModeReglement[]|null
     */
    public function getModeReglement()
    {
        return isset($this->ModeReglement) ? $this->ModeReglement : null;
    }
    /**
     * This method is responsible for validating the values passed to the setModeReglement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setModeReglement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateModeReglementForArrayConstraintsFromSetModeReglement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfModeReglementModeReglementItem) {
            // validation for constraint: itemType
            if (!$arrayOfModeReglementModeReglementItem instanceof \xt_soapapi\xt_soapapi-php\StructType\ModeReglement) {
                $invalidValues[] = is_object($arrayOfModeReglementModeReglementItem) ? get_class($arrayOfModeReglementModeReglementItem) : sprintf('%s(%s)', gettype($arrayOfModeReglementModeReglementItem), var_export($arrayOfModeReglementModeReglementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ModeReglement property can only contain items of type \xt_soapapi\xt_soapapi-php\StructType\ModeReglement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ModeReglement value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \xt_soapapi\xt_soapapi-php\StructType\ModeReglement[] $modeReglement
     * @return \xt_soapapi\xt_soapapi-php\ArrayType\ArrayOfModeReglement
     */
    public function setModeReglement(array $modeReglement = array())
    {
        // validation for constraint: array
        if ('' !== ($modeReglementArrayErrorMessage = self::validateModeReglementForArrayConstraintsFromSetModeReglement($modeReglement))) {
            throw new \InvalidArgumentException($modeReglementArrayErrorMessage, __LINE__);
        }
        if (is_null($modeReglement) || (is_array($modeReglement) && empty($modeReglement))) {
            unset($this->ModeReglement);
        } else {
            $this->ModeReglement = $modeReglement;
        }
        return $this;
    }
    /**
     * Add item to ModeReglement value
     * @throws \InvalidArgumentException
     * @param \xt_soapapi\xt_soapapi-php\StructType\ModeReglement $item
     * @return \xt_soapapi\xt_soapapi-php\ArrayType\ArrayOfModeReglement
     */
    public function addToModeReglement(\xt_soapapi\xt_soapapi-php\StructType\ModeReglement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \xt_soapapi\xt_soapapi-php\StructType\ModeReglement) {
            throw new \InvalidArgumentException(sprintf('The ModeReglement property can only contain items of type \xt_soapapi\xt_soapapi-php\StructType\ModeReglement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ModeReglement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \xt_soapapi\xt_soapapi-php\StructType\ModeReglement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \xt_soapapi\xt_soapapi-php\StructType\ModeReglement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \xt_soapapi\xt_soapapi-php\StructType\ModeReglement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \xt_soapapi\xt_soapapi-php\StructType\ModeReglement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \xt_soapapi\xt_soapapi-php\StructType\ModeReglement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ModeReglement
     */
    public function getAttributeName()
    {
        return 'ModeReglement';
    }
}
