<?php

namespace xt_soapapi\xt_soapapi-php\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfStockMagasin ArrayType
 * @subpackage Arrays
 */
class ArrayOfStockMagasin extends AbstractStructArrayBase
{
    /**
     * The StockMagasin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \xt_soapapi\xt_soapapi-php\StructType\StockMagasin[]
     */
    public $StockMagasin;
    /**
     * Constructor method for ArrayOfStockMagasin
     * @uses ArrayOfStockMagasin::setStockMagasin()
     * @param \xt_soapapi\xt_soapapi-php\StructType\StockMagasin[] $stockMagasin
     */
    public function __construct(array $stockMagasin = array())
    {
        $this
            ->setStockMagasin($stockMagasin);
    }
    /**
     * Get StockMagasin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \xt_soapapi\xt_soapapi-php\StructType\StockMagasin[]|null
     */
    public function getStockMagasin()
    {
        return isset($this->StockMagasin) ? $this->StockMagasin : null;
    }
    /**
     * This method is responsible for validating the values passed to the setStockMagasin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setStockMagasin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateStockMagasinForArrayConstraintsFromSetStockMagasin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfStockMagasinStockMagasinItem) {
            // validation for constraint: itemType
            if (!$arrayOfStockMagasinStockMagasinItem instanceof \xt_soapapi\xt_soapapi-php\StructType\StockMagasin) {
                $invalidValues[] = is_object($arrayOfStockMagasinStockMagasinItem) ? get_class($arrayOfStockMagasinStockMagasinItem) : sprintf('%s(%s)', gettype($arrayOfStockMagasinStockMagasinItem), var_export($arrayOfStockMagasinStockMagasinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The StockMagasin property can only contain items of type \xt_soapapi\xt_soapapi-php\StructType\StockMagasin, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set StockMagasin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \xt_soapapi\xt_soapapi-php\StructType\StockMagasin[] $stockMagasin
     * @return \xt_soapapi\xt_soapapi-php\ArrayType\ArrayOfStockMagasin
     */
    public function setStockMagasin(array $stockMagasin = array())
    {
        // validation for constraint: array
        if ('' !== ($stockMagasinArrayErrorMessage = self::validateStockMagasinForArrayConstraintsFromSetStockMagasin($stockMagasin))) {
            throw new \InvalidArgumentException($stockMagasinArrayErrorMessage, __LINE__);
        }
        if (is_null($stockMagasin) || (is_array($stockMagasin) && empty($stockMagasin))) {
            unset($this->StockMagasin);
        } else {
            $this->StockMagasin = $stockMagasin;
        }
        return $this;
    }
    /**
     * Add item to StockMagasin value
     * @throws \InvalidArgumentException
     * @param \xt_soapapi\xt_soapapi-php\StructType\StockMagasin $item
     * @return \xt_soapapi\xt_soapapi-php\ArrayType\ArrayOfStockMagasin
     */
    public function addToStockMagasin(\xt_soapapi\xt_soapapi-php\StructType\StockMagasin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \xt_soapapi\xt_soapapi-php\StructType\StockMagasin) {
            throw new \InvalidArgumentException(sprintf('The StockMagasin property can only contain items of type \xt_soapapi\xt_soapapi-php\StructType\StockMagasin, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->StockMagasin[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \xt_soapapi\xt_soapapi-php\StructType\StockMagasin|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \xt_soapapi\xt_soapapi-php\StructType\StockMagasin|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \xt_soapapi\xt_soapapi-php\StructType\StockMagasin|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \xt_soapapi\xt_soapapi-php\StructType\StockMagasin|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \xt_soapapi\xt_soapapi-php\StructType\StockMagasin|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string StockMagasin
     */
    public function getAttributeName()
    {
        return 'StockMagasin';
    }
}
