<?php

namespace xt_soapapi\xt_soapapi-php\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LigneCommande StructType
 * @subpackage Structs
 */
class LigneCommande extends AbstractStructBase
{
    /**
     * The NoLigneCommande
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $NoLigneCommande;
    /**
     * The RefFab
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $RefFab;
    /**
     * The Taille
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $Taille;
    /**
     * The Qte
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Qte;
    /**
     * The PxTheo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $PxTheo;
    /**
     * The PourcRemise
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $PourcRemise;
    /**
     * The MtHT
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $MtHT;
    /**
     * The MtTVA
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $MtTVA;
    /**
     * The MtTPB
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $MtTPB;
    /**
     * The MtTTC
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $MtTTC;
    /**
     * The CodeFab
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CodeFab;
    /**
     * The CodeMagasin
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CodeMagasin;
    /**
     * Constructor method for LigneCommande
     * @uses LigneCommande::setNoLigneCommande()
     * @uses LigneCommande::setRefFab()
     * @uses LigneCommande::setTaille()
     * @uses LigneCommande::setQte()
     * @uses LigneCommande::setPxTheo()
     * @uses LigneCommande::setPourcRemise()
     * @uses LigneCommande::setMtHT()
     * @uses LigneCommande::setMtTVA()
     * @uses LigneCommande::setMtTPB()
     * @uses LigneCommande::setMtTTC()
     * @uses LigneCommande::setCodeFab()
     * @uses LigneCommande::setCodeMagasin()
     * @param int $noLigneCommande
     * @param string $refFab
     * @param string $taille
     * @param int $qte
     * @param float $pxTheo
     * @param float $pourcRemise
     * @param float $mtHT
     * @param float $mtTVA
     * @param float $mtTPB
     * @param float $mtTTC
     * @param string $codeFab
     * @param string $codeMagasin
     */
    public function __construct($noLigneCommande = null, $refFab = null, $taille = null, $qte = null, $pxTheo = null, $pourcRemise = null, $mtHT = null, $mtTVA = null, $mtTPB = null, $mtTTC = null, $codeFab = null, $codeMagasin = null)
    {
        $this
            ->setNoLigneCommande($noLigneCommande)
            ->setRefFab($refFab)
            ->setTaille($taille)
            ->setQte($qte)
            ->setPxTheo($pxTheo)
            ->setPourcRemise($pourcRemise)
            ->setMtHT($mtHT)
            ->setMtTVA($mtTVA)
            ->setMtTPB($mtTPB)
            ->setMtTTC($mtTTC)
            ->setCodeFab($codeFab)
            ->setCodeMagasin($codeMagasin);
    }
    /**
     * Get NoLigneCommande value
     * @return int
     */
    public function getNoLigneCommande()
    {
        return $this->NoLigneCommande;
    }
    /**
     * Set NoLigneCommande value
     * @param int $noLigneCommande
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande
     */
    public function setNoLigneCommande($noLigneCommande = null)
    {
        // validation for constraint: int
        if (!is_null($noLigneCommande) && !(is_int($noLigneCommande) || ctype_digit($noLigneCommande))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($noLigneCommande, true), gettype($noLigneCommande)), __LINE__);
        }
        $this->NoLigneCommande = $noLigneCommande;
        return $this;
    }
    /**
     * Get RefFab value
     * @return string
     */
    public function getRefFab()
    {
        return $this->RefFab;
    }
    /**
     * Set RefFab value
     * @param string $refFab
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande
     */
    public function setRefFab($refFab = null)
    {
        // validation for constraint: string
        if (!is_null($refFab) && !is_string($refFab)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($refFab, true), gettype($refFab)), __LINE__);
        }
        $this->RefFab = $refFab;
        return $this;
    }
    /**
     * Get Taille value
     * @return string
     */
    public function getTaille()
    {
        return $this->Taille;
    }
    /**
     * Set Taille value
     * @param string $taille
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande
     */
    public function setTaille($taille = null)
    {
        // validation for constraint: string
        if (!is_null($taille) && !is_string($taille)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($taille, true), gettype($taille)), __LINE__);
        }
        $this->Taille = $taille;
        return $this;
    }
    /**
     * Get Qte value
     * @return int
     */
    public function getQte()
    {
        return $this->Qte;
    }
    /**
     * Set Qte value
     * @param int $qte
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande
     */
    public function setQte($qte = null)
    {
        // validation for constraint: int
        if (!is_null($qte) && !(is_int($qte) || ctype_digit($qte))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($qte, true), gettype($qte)), __LINE__);
        }
        $this->Qte = $qte;
        return $this;
    }
    /**
     * Get PxTheo value
     * @return float
     */
    public function getPxTheo()
    {
        return $this->PxTheo;
    }
    /**
     * Set PxTheo value
     * @param float $pxTheo
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande
     */
    public function setPxTheo($pxTheo = null)
    {
        // validation for constraint: float
        if (!is_null($pxTheo) && !(is_float($pxTheo) || is_numeric($pxTheo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($pxTheo, true), gettype($pxTheo)), __LINE__);
        }
        $this->PxTheo = $pxTheo;
        return $this;
    }
    /**
     * Get PourcRemise value
     * @return float
     */
    public function getPourcRemise()
    {
        return $this->PourcRemise;
    }
    /**
     * Set PourcRemise value
     * @param float $pourcRemise
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande
     */
    public function setPourcRemise($pourcRemise = null)
    {
        // validation for constraint: float
        if (!is_null($pourcRemise) && !(is_float($pourcRemise) || is_numeric($pourcRemise))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($pourcRemise, true), gettype($pourcRemise)), __LINE__);
        }
        $this->PourcRemise = $pourcRemise;
        return $this;
    }
    /**
     * Get MtHT value
     * @return float
     */
    public function getMtHT()
    {
        return $this->MtHT;
    }
    /**
     * Set MtHT value
     * @param float $mtHT
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande
     */
    public function setMtHT($mtHT = null)
    {
        // validation for constraint: float
        if (!is_null($mtHT) && !(is_float($mtHT) || is_numeric($mtHT))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($mtHT, true), gettype($mtHT)), __LINE__);
        }
        $this->MtHT = $mtHT;
        return $this;
    }
    /**
     * Get MtTVA value
     * @return float
     */
    public function getMtTVA()
    {
        return $this->MtTVA;
    }
    /**
     * Set MtTVA value
     * @param float $mtTVA
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande
     */
    public function setMtTVA($mtTVA = null)
    {
        // validation for constraint: float
        if (!is_null($mtTVA) && !(is_float($mtTVA) || is_numeric($mtTVA))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($mtTVA, true), gettype($mtTVA)), __LINE__);
        }
        $this->MtTVA = $mtTVA;
        return $this;
    }
    /**
     * Get MtTPB value
     * @return float
     */
    public function getMtTPB()
    {
        return $this->MtTPB;
    }
    /**
     * Set MtTPB value
     * @param float $mtTPB
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande
     */
    public function setMtTPB($mtTPB = null)
    {
        // validation for constraint: float
        if (!is_null($mtTPB) && !(is_float($mtTPB) || is_numeric($mtTPB))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($mtTPB, true), gettype($mtTPB)), __LINE__);
        }
        $this->MtTPB = $mtTPB;
        return $this;
    }
    /**
     * Get MtTTC value
     * @return float
     */
    public function getMtTTC()
    {
        return $this->MtTTC;
    }
    /**
     * Set MtTTC value
     * @param float $mtTTC
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande
     */
    public function setMtTTC($mtTTC = null)
    {
        // validation for constraint: float
        if (!is_null($mtTTC) && !(is_float($mtTTC) || is_numeric($mtTTC))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($mtTTC, true), gettype($mtTTC)), __LINE__);
        }
        $this->MtTTC = $mtTTC;
        return $this;
    }
    /**
     * Get CodeFab value
     * @return string|null
     */
    public function getCodeFab()
    {
        return $this->CodeFab;
    }
    /**
     * Set CodeFab value
     * @param string $codeFab
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande
     */
    public function setCodeFab($codeFab = null)
    {
        // validation for constraint: string
        if (!is_null($codeFab) && !is_string($codeFab)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codeFab, true), gettype($codeFab)), __LINE__);
        }
        $this->CodeFab = $codeFab;
        return $this;
    }
    /**
     * Get CodeMagasin value
     * @return string|null
     */
    public function getCodeMagasin()
    {
        return $this->CodeMagasin;
    }
    /**
     * Set CodeMagasin value
     * @param string $codeMagasin
     * @return \xt_soapapi\xt_soapapi-php\StructType\LigneCommande
     */
    public function setCodeMagasin($codeMagasin = null)
    {
        // validation for constraint: string
        if (!is_null($codeMagasin) && !is_string($codeMagasin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codeMagasin, true), gettype($codeMagasin)), __LINE__);
        }
        $this->CodeMagasin = $codeMagasin;
        return $this;
    }
}
